#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main(){
    int N,Q;
    cin>>N>>Q;
    vector<long long> di(N);
    vector<long long> ki(N);
    for(long long i=1;i<=N;i++){
        cin>>di[i]>>ki[i];
    }
    vector<long long> p(Q);
    for(long long i=1;i<=Q;i++){
        cin>>p[i];
    }
    long long dostupnost;
    long long pojedeno;
    long long k;
    for(long long n=1;n<=Q;n++){
        dostupnost=0;
        pojedeno=0;
        k=1;
        for(long long i=1;i<=p[n];i++){
            if(i==di[k]){
                dostupnost=dostupnost+ki[k];
                k=k+1;
            }
            if(dostupnost!=0){
                dostupnost=dostupnost-1;
                pojedeno=pojedeno+1;
            }
        }
        cout<<pojedeno<<endl;
   }
    return 0;
}